﻿using Buddy.Coroutines;
using Styx;
using Styx.Common;
using Styx.CommonBot;
using Styx.CommonBot.Coroutines;
using Styx.CommonBot.Frames;
using Styx.Plugins;
using Styx.WoWInternals;
using Styx.WoWInternals.DB;
using Styx.WoWInternals.WoWObjects;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using System.Windows.Media;

namespace DreamSeeds
{
    public class DreamSeeds : HBPlugin
    {
        private static bool _looted = false;
        private static bool _initialized = false;
        private static bool _quit = false;
		public Styx.WoWInternals.WoWObjects.LocalPlayer Me { get { return Styx.StyxWoW.Me; } } 

        public override string Author
        {
            get
            {
                return "pstolpackr";
            }
        }

        public override string Name
        {
            get
            {
                return "Use Dream Seeds";
            }
        }

        public override Version Version
        {
            get
            {
                return new Version(0, 0, 0, 1);
            }
        }

        public override bool WantButton
        {
            get
            {
                return false;
            }
        }

        public override string ButtonText
        {
            get
            {
                return "";
            }
        }

        public override void OnButtonPress()
        {

        }

        public override void OnEnable()
        {
            if (!_initialized)
            {
                BotEvents.OnBotStopped += OnBotStopped;
                BotEvents.OnBotStarted += OnBotStarted;
                _initialized = true;
            }
        }

        private void OnBotStarted(EventArgs args)
        {
            _quit = false;
        }

        private void OnBotStopped(EventArgs args)
        {
            StopCoroutine();
        }

        public override void OnDisable()
        {
            if (_initialized)
            {
                BotEvents.OnBotStopped -= OnBotStopped;
                BotEvents.OnBotStarted -= OnBotStarted;
                _initialized = false;
            }
        }

        public override void Pulse()
        {
            if (_coroutine == null || _coroutine.IsFinished)
            {
                if (_coroutine != null && !_quit)
                    Log("DreamSeeds plugin coroutine ended, which it never should! Restarting", LogLevel.Diagnostic);

                _coroutine = new Coroutine(() => MainCoroutine());
            }

            try
            {
                _coroutine.Resume();
            }

            catch (Exception ex)
            {
                Logging.WriteDiagnostic(Colors.Red, ex.Message);
            }

        }

        private Coroutine _coroutine;

        private void StopCoroutine()
        {
            _quit = true;
            if (_coroutine == null)
                return;

            _coroutine.Dispose();
            _coroutine = null;
        }

		private bool UseItem(Styx.WoWInternals.WoWObjects.WoWItem item) 
		{ 
			// these were split up to make it easier to read.  You can put them together if you decide to  

			if (item == null) { return false; }         // if the item is null, don't use  
			if (!item.Usable) { return false; }         // if the item is not usable, don't use  
			if (item.Cooldown > 0) { return false; }    // if it is still on cooldown, don't use  
			if (Styx.CommonBot.Frames.MerchantFrame.Instance.IsVisible) { return false; } // if you have a merchant frame up, don't use 

			if (item.Use()) 
			{ 
				return true; 
			} 
			return false; 
		}  
		
		private async Task UseDreamSeeds() 
		{ 
			// wait for our GCD to use the seeds 
			await Buddy.Coroutines.Coroutine.Sleep(Styx.CommonBot.SpellManager.GlobalCooldownLeft); 

			int DreamSeeds = 139380;  
			var item = Me.BagItems.FirstOrDefault(i => i.ItemInfo.Id == DreamSeeds); 

			
			UseItem(item); 

			await Buddy.Coroutines.Coroutine.Sleep(1000); 

		}  
		
        private async Task MainCoroutine()
        {
            while (!_quit)
            {
                try
                {
                    Log("Running Logic @ " + DateTime.Now, LogLevel.Diagnostic);
                    if (LootFrame.Instance != null && LootFrame.Instance.IsVisible)
                    {
                        await UseDreamSeeds();
                    }

                    await Coroutine.Yield();
                }
                catch (Exception ex)
                {
                    Logging.WriteDiagnostic(ex.ToString());
                }
            }
        }

        private async void LOOT_CLOSED(object sender, LuaEventArgs args)
        {
            _looted = true;
            await Task.Delay(SpellManager.GlobalCooldownLeft);
        }

        private void Log(string v, LogLevel l)
        {
            Logging.Write(l, Colors.Aquamarine, string.Format("[DreamSeeds] {0}", v));
        }
    }
}

